package com.example.random.inventdroid;

import android.Manifest;
import android.app.Activity;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.net.Uri;
import android.os.Environment;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.google.zxing.integration.android.IntentIntegrator;
import com.google.zxing.integration.android.IntentResult;

import java.io.File;
import java.io.IOException;

import jxl.Workbook;
import jxl.read.biff.BiffException;
import jxl.write.Label;
import jxl.write.WritableSheet;
import jxl.write.WritableWorkbook;
import jxl.write.WriteException;
import jxl.write.biff.RowsExceededException;

public class Captura extends AppCompatActivity {

    //Definición de variable de entorno tanto de vistas como de uso.
    Button scan,send,plus,less,save;
    EditText quantity,code;
    TextView zone;
    int number=1;
    int row=1;
    String workBook,zona,user,invent;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_captura);

        //Rescate de variables de  actividad que llama
        Bundle extras=getIntent().getExtras();
        workBook=extras.getString("nameFile");
        zona=extras.getString("zona");
        invent=extras.getString("invent");
        user=extras.getString("user");


        //Bloquear rotación Pantalla
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        //Ocultar el ActionBar
        getSupportActionBar().hide();
        final Activity activity = this;

        //Asociamos vistas a controlador
        scan = (Button) findViewById(R.id.bt_Scan);
        send = (Button) findViewById(R.id.bt_send);
        plus = (Button) findViewById(R.id.bt_plus);
        less = (Button) findViewById(R.id.bt_less);
        quantity = (EditText) findViewById(R.id.te_quanty);
        code = (EditText) findViewById(R.id.te_codeBar);
        zone = (TextView) findViewById(R.id.tv_invent_zone);
        zone.setText(workBook);
        save=(Button) findViewById(R.id.bt_Save);


        //Definimos la función del botón send que se encarga del envio del fichero xls
        send.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                //Obtenemos el fichero para enviarlo.
                Uri uri=Uri.fromFile(new File(Environment.getExternalStorageDirectory().getAbsolutePath()+"/InventDroid/",workBook));
                //Generamos el intent de envío de email
                Intent i= new Intent(Intent.ACTION_SEND);
                i.setType("InventDroid/"+workBook);
                i.putExtra(Intent.EXTRA_STREAM,uri);
                startActivity(Intent.createChooser(i,"Enviar Fichero por:"));

            }
        });

        //Definimos el botón save que añade líneas capturadas al fichero xls
        save.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                writeBook(workBook,row,quantity.getText().toString(),code.getText().toString(),user,zona,invent);

                //Incrementa una row por cada captura para ser secuencial

                row=row+1;
                // Ponemos a cero los valores del cód ean y la cantidad a 1 para facilitar la entrada siguiente
                code.setText("");
                quantity.setText("1");

            }
        });

        String stringNumber = String.valueOf(number);
        quantity.setText(stringNumber);
        try {
           createBook(workBook);
        } catch (IOException e) {
            e.printStackTrace();
        }

        // Acciones para aumentar o redurir la cantidad del código capturado
        plus.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                number = number + 1;
                String stringNumber = String.valueOf(number);
                quantity.setText(stringNumber);
            }
        });
        less.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (number > 1) {
                    number = number - 1;
                    String stringNumber = String.valueOf(number);
                    quantity.setText(stringNumber);
                }
            }

            ;
        });

        // Asignación de captura de código
        scan.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                IntentIntegrator integrator = new IntentIntegrator(activity);
                integrator.setDesiredBarcodeFormats(IntentIntegrator.ALL_CODE_TYPES);
                integrator.setPrompt("Scan");
                integrator.setCameraId(0);
                integrator.setBeepEnabled(true);
                integrator.setBarcodeImageEnabled(false);
                integrator.initiateScan();
            }
        });


    }
        @Override
        protected void onActivityResult(int requestCode, int resultCode, Intent data) {
            super.onActivityResult(requestCode, resultCode, data);

            IntentResult result = IntentIntegrator.parseActivityResult(requestCode, resultCode, data);
            if(result != null) {
                if(result.getContents() == null) {
                    Log.d("MainActivity", "Cancelled scan");
                    Toast.makeText(this, "Cancelled", Toast.LENGTH_LONG).show();
                } else {
                    Log.d("MainActivity", "Scanned");
                    // Toast.makeText(this, "Scanned: " + result.getContents(), Toast.LENGTH_LONG).show();
                    code.setText(result.getContents());
                }
            }

        }

//Función para la creación del nuevo fichero
        public  void createBook (String file) throws IOException {


        String nameFile =file;
            try {
                //Selecciona el destino del fichero a crear
                File sdCard = Environment.getExternalStorageDirectory();
                File dir = new File(sdCard.getAbsolutePath() + "/InventDroid");
                dir.mkdirs();
                WritableWorkbook wb= Workbook.createWorkbook(new File(sdCard.getAbsolutePath() + "/InventDroid/"+nameFile));
                WritableSheet sheet= wb.createSheet("InventDroid",0);
                Label label0=new Label(0,0,"InventID");
                Label label1=new Label(1,0,"userId");
                Label label2=new Label(2,0,"Zone");
                Label label3=new Label(3,0,"Code EAN");
                Label label4=new Label(4,0,"Quantity");
                sheet.addCell(label0);
                sheet.addCell(label1);
                sheet.addCell(label2);
                sheet.addCell(label3);
                sheet.addCell(label4);

                wb.write();
                wb.close();



            } catch (IOException e) {
                e.printStackTrace();
            } catch (RowsExceededException e) {
                e.printStackTrace();
            } catch (WriteException e) {
                e.printStackTrace();
            }


        }


//Función que añade cada captura al fichero creado
    public  void  writeBook (String file, int r, String qu, String cod, String u,String z,String i){


        try {
            File sdCard = Environment.getExternalStorageDirectory();
            Workbook wb=Workbook.getWorkbook(new File(sdCard.getAbsolutePath()+"/InventDroid/"+file));
            WritableWorkbook copy=Workbook.createWorkbook(new File(sdCard.getAbsolutePath()+"/InventDroid/"+file),wb);
            WritableSheet sheet= (WritableSheet) copy.getSheet("InventDroid");
            Label label0=new Label(0,r,i);
            Label label1=new Label(1,r,u);
            Label label2=new Label(2,r,z);
            Label label3=new Label(3,r,cod);
            Label label4=new Label(4,r,qu);

            sheet.addCell(label0);
            sheet.addCell(label1);
            sheet.addCell(label2);
            sheet.addCell(label3);
            sheet.addCell(label4);
            copy.write();
            copy.close();

        } catch (IOException e) {
            e.printStackTrace();
        } catch (BiffException e) {
            e.printStackTrace();
        } catch (RowsExceededException e) {
            e.printStackTrace();
        } catch (WriteException e) {
            e.printStackTrace();
        }

    }
    public void lanzarHome (View view){
        Intent i=new Intent(this,MainActivity.class);
        startActivity(i);
    }
}
