package com.example.random.inventdroid;

import android.util.Log;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;

/**
 * Created by Random on 18/12/2017.
 */

public class webServices {

//////////////// ///////////////////////////////////////////////////////////////////////////////////////////////
// Función para la creación de un nuevo usuario :
//   Variables del constructor (n:nombre,p:apellidos1,p2:apellido2,c:compañia,m:e-mail,t:tipo de usuario
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    public void nuevoUsuario(String n, String p, String p2, String c, String m, String t) throws IOException {

        //Sutituimos los espacios vacios de las variables con "%20" para poder construir correctamente la URL
        n = n.replace(" ", "%20");
        p = p.replace(" ", "%20");
        p2 = p2.replace(" ", "%20");
        c = c.replace(" ", "%20");
        m = m.replace(" ", "%20");
        t = t.replace(" ", "%20");
        ///////////////////////////////////////////////////////////////////////////////////////////////////////
        //Modificar Url si se cambia hosting
        URL url = new URL("http://www.enzoom.eu/inventDroid/insertarUsuario.php?nombre=" + n + "&apellido1=" + p + "&apellido2=" + p2 + "&company=" + c + "&email=" + m + "&u_tipe=" + t);
        HttpURLConnection conexion = (HttpURLConnection) url.openConnection();

        try {
            if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
                BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
                String linea = reader.readLine();
                if (!linea.equals("Ok")) {
                    Log.e("Ruben", "Error en el servicio!!!");
                } else {
                    Log.e("Ruben", conexion.getResponseMessage());
                }
            }
        } catch (Exception e) {
            Log.e("Ruben", e.getMessage(), e);
        } finally {
            conexion.disconnect();
        }

    }
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//////////////// ///////////////////////////////////////////////////////////////////////////////////////////////
/////MOdificar datos de usuario por ID:
/// Variables del constructor (n:nombre,s1:apellidos1,s2:apellido2,c:compañia,m:e-mail,t:tipo de usuario
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
public void requestUserId(String n,String i,String s1,String s2,String c, String m, String t ) throws IOException {

//Susituimos los espacios vacios de las variables con "%20" para poder construir correctamente la URL
    n=n.replace(" ","%20");
    i=i.replace(" ","%20");
    s1=s1.replace(" ","%20");
    s2=s2.replace(" ","%20");
    c=c.replace(" ","%20");
    m=m.replace(" ","%20");
    t=t.replace(" ","%20");
    //Modificar Url si se cambia hosting
    URL url = new URL("http://www.enzoom.eu/inventDroid/modificarUsuario.php?" +
            "nombre="+n+
            "&userId="+i+
            "&apellido1="+s1+
            "&apellido2="+s2+
            "&company="+c+
            "&email="+m+
            "&u_tipe="+t


    );
    HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
    try {
        Log.e("Ruben", String.valueOf(url));
        if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
            BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
            String linea = reader.readLine();
            if (!linea.equals("Ok")) {
                Log.e("Ruben", "Error en el servicio requestUserId !!!");
            } else {
                Log.e("Ruben", conexion.getResponseMessage());
            }
        }
    } catch (Exception e) {
        Log.e("Ruben", e.getMessage(), e);
    } finally {
        conexion.disconnect();
    }

}
 ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//////////////// ///////////////////////////////////////////////////////////////////////////////////////////////
/////   Función para insertar zona en inventario
///    Variables del constructor ( z=zona  de inventario, d=descripción de la zona i=ide del inventario
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   public void addZone(String z,String d, String i) throws IOException {

        //Sutituimos los espacios vacios de las variables con "%20" para poder construir correctamente la URL
        d=d.replace(" ","%20");


       //Modificar Url si se cambia hosting
        URL url = new URL("http://www.enzoom.eu/inventDroid/insertarZone.php?zone="+z+"&zoneDesc="+d+"&inventId="+i+"");
        HttpURLConnection conexion = null;
        try {
            conexion = (HttpURLConnection) url.openConnection();
        } catch (IOException e) {
            e.printStackTrace();
        }

        try {
            if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
                BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
                String linea = reader.readLine();
                if (!linea.equals("Ok")) {
                    Log.e("Ruben", "Error en el servicio addZone!!!");
                } else {
                    Log.e("Ruben", conexion.getResponseMessage());
                }
            }
        } catch (Exception e) {
            Log.e("Ruben", e.getMessage(), e);
        } finally {
            conexion.disconnect();
        }

    }

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////  Función para nuevo inventario
///    Variables del constructor ( nameOwnwr=Nombre del propietario del inventario , mail=mail del propietario, userId=ide del propietario
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    public void newInvent(String nameOwner,String mail, String userId) throws IOException {

        //Sutituimos los espacios vacios de las variables con "%20" para poder construir correctamente la URL
//        nameOwner=nameOwner.replace(" ","%20");

        //Modificar Url si se cambia hosting
        URL url = new URL("http://www.enzoom.eu/inventDroid/insertarInventario.php?userOwner="+nameOwner+"&mailOwner="+mail+"&userId="+userId+"");
        HttpURLConnection conexion = null;
        try {
            conexion = (HttpURLConnection) url.openConnection();
        } catch (IOException e) {
            e.printStackTrace();
        }

        try {
            if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
                BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
                String linea = reader.readLine();
                if (!linea.equals("Ok")) {
                    Log.e("Ruben", "Error en el servicio de añadir inventari !!!");
                } else {
                    Log.e("Ruben", conexion.getResponseMessage());
                }
            }
        } catch (Exception e) {
            Log.e("Ruben", e.getMessage(), e);
        } finally {
            conexion.disconnect();
        }

    }

 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////// ///////////////////////////////////////////////////////////////////////////////////////////////
/////   Función para listar zonas de inventario
///    Variables del constructor ( i=ide del inventario
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    public void listInvent( String i) throws IOException {




        //Modificar Url si se cambia hosting
        URL url = new URL("http://www.enzoom.eu/inventDroid/consultaInvent.php?inventId="+i+"");
        HttpURLConnection conexion = null;
        try {
            conexion = (HttpURLConnection) url.openConnection();
        } catch (IOException e) {
            e.printStackTrace();
        }

        try {
            if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
                BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
                String linea = reader.readLine();
                if (!linea.equals("Ok")) {
                    Log.e("Ruben", "Error en el servicio ListInvent!!!");
                } else {
                    Log.e("Ruben", conexion.getResponseMessage());
                }
            }
        } catch (Exception e) {
            Log.e("Ruben", e.getMessage(), e);
        } finally {
            conexion.disconnect();
        }

    }

///////////////////////////////////////////////////////////////////////////////////////////////////////


}
